/* Copyright (C) 1998 Free Software Foundation, Inc.

   This file is part of GNU Motti.

   GNU Motti is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GNU Motti is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Motti; see the file COPYING.  If not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#ifndef _MAP_H

#define _MAP_H 1

#define MASK_PLAYER 15
#define MASK_PLAIN 31
#define MASK_OCCUPIED 16
#define MASK_CAPITAL 32
#define MASK_CROSS 64
#define MASK_PASSED 128
#define SEA_VAL 0
#define N_CROSS 6
#define MODE_ATT 1
#define MODE_DEF 2
#define MODE_GUE 4

#define MAXPLAYERS 2

typedef struct
{
  short x, y;
} Coord;

#define EVENT_ATT 0
#define EVENT_DEF 1
#define EVENT_GUE 2
#define MASK_EVENT_ENCIRCLEMENT 4

typedef struct
{
  int count, base_count;
  char type;
  Coord *loc;
} Action;

typedef unsigned char map_val;

typedef struct
{
  unsigned short width, height;
  unsigned short warped;
  Coord *capital;
  Coord cross[N_CROSS];
  unsigned short size;
  unsigned char players, n_cross, n_att;
  unsigned char bit_cross, modes, def_mode, turn, op_val;
  map_val *map;
} Map;

extern int loadMap(char *, Map *);
extern void get_map_real_coord(Coord *, Map);
extern map_val get_map_val(Map, Coord);
extern Coord add_coord(Coord, Coord);
extern int cmp_coord(Map, Coord, Coord);
extern void set_map(Map *, Coord, map_val);
extern void set_map_bit(Map *, Coord, map_val);
extern void clear_map_bit(Map *, Coord, map_val);
extern int check_cross(Map *, Coord);
extern int toggle_cross(Map *, Coord);
extern void action(Map *, int, Action *);
extern void clean_map(Map *, map_val);

#endif /* map.h  */
