/* Copyright (C) 1998 Free Software Foundation, Inc.

   This file is part of GNU Motti.

   GNU Motti is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GNU Motti is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Motti; see the file COPYING.  If not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#ifndef _SNAKES_H

#define _SNAKES_H

#define CLOCKWISE 0
#define C_CLOCKWISE 1

#include "map.h"

typedef struct
{
  Coord begin;
  unsigned short players;
} Region;

typedef enum
{
  NW, N, NE, E, SE, S, SW, W
} Bearing;

extern int count_areas(Map *, Coord, Region **);
extern map_val get_surrounding_val(Map *, Coord, Bearing);
extern int find_capital(Map *, Coord, int);
extern void encircled(Map *, Coord, Coord, int, Action *);
#endif /* snakes.h  */
