/* Copyright (C) 1998 Free Software Foundation, Inc.

   This file is part of GNU Motti.

   GNU Motti is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GNU Motti is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Motti; see the file COPYING.  If not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <stdlib.h>
#include <stdio.h>

#include "xinit.h"
#include "xwin.h"
#include "xevent.h"

extern Bool color;

Display *display;

static void die()
{
  XCloseDisplay(display);
}

int main(int argc, char **argv)
{
  XMapStruct xmap = {{0}, {0}};

  XrmInitialize();
  /* Open display and parse command line arguments */
  openDisplay(&argc, argv);

  //  atexit(&die());

  /* Complete the database */
  createFinalDB();
  /* Allocate all needed colors or declare BW mode */
  allocColors();
  if(color == False)
    {
      fprintf(stderr, "Sorry, BW not implemented yet.\n");
      exit(1);
    }

  loadMap("map", &xmap.map);

  /* Open windows */
  openWindows(argc, argv, &xmap);

  create_cursors();

  eventLoop(&xmap);

  exit(0);
}
